	org $1001-2
	dw  $1001
	
	include "!playerv.asm"
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

CHAR_WIDTH	= 18
CHARS		= $F000
CODE_DEST	= $3100
SINE		= CHARS - (CHAR_WIDTH*4+1) * $100
TXT_FLAGS	= $F800	; $500 bytes

BITMAP		= $4000
COLMAP		= $3800

sine_index	= $02

index		= $F5
mult		= $F5
ptr		= $F6
ptr2		= $F8
dest		= $FA	; 16 bit
chr_ptr		= $FC	; 16 bit
txt_ptr		= $FE	; 16 bit

pb	macro the_byte
	lda #the_byte
	jsr putbyte
	endm
	
pw	macro the_byte1, the_byte2
	lda #the_byte1
	jsr putbyte
	lda #the_byte2
	jsr putbyte
	endm
	
pzp	macro zp
	lda dest
	jsr putbyte
	lda dest+1
	jsr putbyte
	endm

start
	sei
	sta $ff3f
	;
	jsr PLAYER_INIT
	;
	; ---
	;
	lda #$77
	ldx #$03
	ldy #COLMAP >> 8
	jsr fill
	lda #$11
	ldx #$03
	ldy #(COLMAP >> 8) + 4
	jsr fill
	lda #$71
	sta $FF16
	;
	; ---
	;
	lda #$00
	sta ptr
	sta ptr+2
	lda #$08
	sta ptr+1
	lda #$0C
	sta ptr+3
	;
	lda #$C0
	sta ptr+4
	sta ptr+6
	lda #$0B
	sta ptr+5
	lda #$0F
	sta ptr+7
	;
fl0	lda #$CC
	cmp $FF1D
	bne *-3
	;
	jsr PLAYER
	;
	ldy #$00
fl1	lda $FF19
	and #$7F
	sta (ptr),y
	sta (ptr+4),y
	lda #$A0
	sta (ptr+2),y
	sta (ptr+6),y
	iny
	cpy #40
	bne fl1
	;
	lda ptr
	clc
	adc #40
	sta ptr
	sta ptr+2
	bcc *+6
	inc ptr+1
	inc ptr+3
	;
	lda ptr+4
	sec
	sbc #40
	sta ptr+4
	sta ptr+6
	bcs *+6
	dec ptr+5
	dec ptr+7
	;
	lda ptr+4
	cmp #$b8
	bne fl0
	;
	; ================================================
	;
	lda #$0B
	sta $FF06
	;
	lda $FF07
	and #$40
	beq r1				; PAL, no changes
	;
	lda #$EA
	sta r1+5
	sta r1+6
	lda #$F3
	sta r2+1
	lda #$E4
	sta r3+1
	sta r5+1
	lda #$6A
	sta r6+1
	;
r1	lda #$00
	cmp $FF1D
	bne *-3
	ldx $0800
r2	lda #$10
	cmp $FF1D
	bne *-3
	stx $FF19
	;
	lda r3+1
	cmp #$E0
	bcc *+5
	jsr PLAYER
	;
	ldx #$71
r3	lda #$FF
	cmp $FF1D
	bne *-3
	stx $FF19
	;
	lda r3+1
	cmp #$E0
	bcs *+5
	jsr PLAYER
	;
	lda r2+1
	clc
	adc #$02
r5	cmp #$38
	bne r4
	;
	ldx r1+1
	bne r4
	;
	lda #$37
	sta r1+1
	lda #$00
	;
r4	sta r2+1
	;
	lda r3+1
	sec
	sbc #$02
	sta r3+1
r6	cmp #$6B
	bne r1
	;
	; ================================================
	;
	lda #$CD
	cmp $FF1D
	bne *-3
	;
	lda #$3B			; turn graphics mode on
	sta $FF06
	;
	lda $FF07			; PAL/NTSC friendly
	and #$40
	ora #$18			; $18 = multicolor
	sta $FF07
	;
	lda $FF12
	and #$03			; keep lowest 2 bits (sound)	
	ora #BITMAP >> 10
	sta $FF12
	;
	lda #COLMAP >> 8		; color map
	sta $FF14
	;
fade1	lda #$CC
	cmp $FF1D
	bne *-3
	;
	jsr PLAYER
	;
fade_index
	ldx #$00
	lda fade_color1,x
	sta $FF16
	lda fade_color2,x
	tay
	lda fade_color3,x
	;
	ldx #$03
	jsr fill
	;
	lda fade_index+1
	clc
	adc #$01
	sta fade_index+1
	cmp #fade_color2-fade_color1
	bne fade1
	;
	asl $FF09
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	lda #$AC
	sta $FF0B
	cli
	;
	; ================================================
	;
	jsr init_sine
	;
	; --- fade out
	;
fade2	lda #$CC
	cmp $FF1D
	bne *-3
	;
fade_index_2
	ldx #(fade_color2-fade_color1-1)
	lda fade_color1,x
	sta $FF16
	lda fade_color2,x
	tay
	lda fade_color3,x
	;
	ldx #$03
	jsr fill
	;
	lda fade_index_2+1
	sec
	sbc #$01
	sta fade_index_2+1
	bpl fade2
	;
	; ---
	;
	lda #$0B			; from here on, $3500 is overwritten
	sta $FF06			; so the screen must be off
	;
	jsr generate_code
	;
	lda #$00
	ldx #$04
	ldy #TXT_FLAGS >> 8
	jsr fill
	;
	;lda #$61
	;sta $FF15
	;lda #$41
	;sta $FF19
	lda $FF07
	and #$40
	ora #$88
	sta $FF07 
	;
	lda #$00
	ldy #CHARS >> 8
	ldx #$07
	jsr fill
	;
	lda $FF12
	and #$03
	sta $FF12
	lda #CHARS >> 8
	sta $FF13
	lda #$08
	sta $FF14
	;
	lda #$15
	ldx #$03
	ldy #$08
	jsr fill
	;
	lda #$09
	sta $0BC0-40+19
	sta $0BC0-40+20
	sta $0BC0+19
	sta $0BC0+20
	;
	lda #$FF
	ldx #$03
	ldy #$0C
	jsr fill
	;
	jsr draw_char_mask
	;
	; ---
	;
	ldx #$00
il1	lda #$00
	clc
	adc adc_vs
	eor eor_vs
	sta il1+1
	and #$7F
	sta sine_index,x
	inx
	cpx #200
	bne il1
	;
	jsr ms2
	;
	; ---
	;
	lda #char_data & 255
	sta chr_ptr
	lda #char_data >> 8
	sta chr_ptr+1
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	;
	sei
	;
	lda #$1B
	sta $FF06
	;
main
	lda #$A1
	cmp $FF1D
	bne *-3
	;
	;dec $FF19
	jsr PLAYER
	jsr modify_sine
	;inc $FF19
	;
;	lda $FF1D
;	cmp $0700
;	bcc *+5
;	sta $0700
	;
	lda #$CB
	cmp $FF1D
	bne *-3
	;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	;
	lda #$08
	sta $FF19
	;
	ldx #$14
	dex
	bpl *-1
	;
	lda #$71
	sta $FF19
	;
	;dec $FF19
	jsr write_text
	jsr CODE_DEST			; call generated code
	;inc $FF19
	;
	jmp main
	
fade_color1
	db $71,$72,$62,$52,$52,$42,$42,$32,$32
fade_color2
	db (COLMAP >> 8) + 4
	db (COLMAP >> 8) + 4
	db COLMAP >> 8
	db COLMAP >> 8
	db COLMAP >> 8
	db COLMAP >> 8
	db COLMAP >> 8
	db COLMAP >> 8
	db COLMAP >> 8
fade_color3
	db $11,$58,$66,$55,$45,$34,$24,$13,$03
	
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
	
	; x = pages
	; y = address hi
	; a = fill with
fill
	sty ptr+1
	ldy #$00
	sty ptr
	;
f1	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	bne f1
	;
	inc ptr+1
	dex
	bpl f1
	rts
	
draw_char_mask
	ldx #$00
	stx ptr
	lda #$0C
	sta ptr+1
	;       
	ldx #$00
dcm2	txa
	pha
	;
	lda #40
	sec
	sbc widths,x
	lsr a
	tay
	lda widths,x
	tax
	dex
	;	
dcm1	lda #$00
	sta (ptr),y
	iny
	inc dcm1+1
	dex
	bpl dcm1
	;
	lda ptr
	clc
	adc #40
	sta ptr
	bcc *+4
	inc ptr+1
	;
	pla
	tax
	inx
	cpx #25				; stop at 25th row
	bne dcm2
	;
	rts
	
init_sine
	lda #$00
	sta ptr
	lda #$80
	sta ptr2
	lda #SINE >> 8
	sta ptr+1
	sta ptr2+1
	;
	lda #$00
	sta is_add+1 
	lda #(CHAR_WIDTH*8)
is0	sta is_mul+1
	lsr a
	tay
	lda #$51
	sta $0C00,y
	;
	ldy #$7F			; length of each table
is1	lda sine_orig,y
	sta num1+1
is_mul	ldx #$00
	lda #$00
	sta mult
	;
is_mult	clc
num1	adc #$00
	bcc *+4
	inc mult
	dex
	bne is_mult
	;
	lda mult
	clc
is_add	adc #$00 
	tax
	;
	and #$F8
	sta (ptr),y
	txa
	and #$07
	tax
	lda bits,x
	sta (ptr2),y
	dey
	bpl is1
	;
	; ---
	;
	inc ptr+1
	inc ptr2+1
	;
	inc is_add+1
	lda is_mul+1
	sec
	sbc #$02
	bcs is0
	;
	rts
	
bits
	db $80,$40,$20,$10,$08,$04,$02,$01
	
sine_orig
; 2nd value =(CHAR_WIDTH*4-0.5)
; 256,127.5,0,192
	db $FF,$FF,$FF,$FF,$FE,$FE,$FE,$FD,$FD,$FC,$FB,$FA,$FA,$F9,$F8,$F6
	db $F5,$F4,$F3,$F1,$F0,$EE,$ED,$EB,$EA,$E8,$E6,$E4,$E2,$E0,$DE,$DC
	db $DA,$D7,$D5,$D3,$D0,$CE,$CB,$C9,$C6,$C4,$C1,$BE,$BC,$B9,$B6,$B3
	db $B0,$AD,$AA,$A7,$A5,$A2,$9E,$9B,$98,$95,$92,$8F,$8C,$89,$86,$83
	db $80,$7C,$79,$76,$73,$70,$6D,$6A,$67,$64,$61,$5D,$5A,$58,$55,$52
	db $4F,$4C,$49,$46,$43,$41,$3E,$3B,$39,$36,$34,$31,$2F,$2C,$2A,$28
	db $25,$23,$21,$1F,$1D,$1B,$19,$17,$15,$14,$12,$11,$0F,$0E,$0C,$0B
	db $0A,$09,$07,$06,$05,$05,$04,$03,$02,$02,$01,$01,$01,$00,$00,$00
	
modify_sine
ms_delay
	lda #$00
	beq ms_x
	;
	inc ms_delay+1
	rts

ms_x	ldx #$00			; self-mod
	ldy #07				; 8 rows at a time
ms1
a_value	lda #$00
	clc
adc_v	adc #$00
eor_v	eor #$00
	sta a_value+1
	and #$7F
	sta sine_index,x
	inx
	dey
	bpl ms1
	;
	stx ms_x+1
	;
	; --
	;
	dex
	lda chr_add,x
	sta ptr
	lda #CHARS >> 11
	sta ptr+1
	;
	asl ptr
	rol ptr+1
	asl ptr
	rol ptr+1
	asl ptr
	rol ptr+1
	;
	txa
	lsr a
	lsr a
	lsr a
	tax
	lda widths,x
	asl a
	asl a
	asl a
	sta ms5+1
	;
	lda #$00
	tay
ms4	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
ms5	cpy #$00
	bne ms4 
	;
	; --
	;
	ldx ms_x+1
	cpx #200
	beq ms2
	;
	rts
	
ms2	inc ms_delay+1			; go into delay mode
	;
ms_idx	lda #$00
	clc
	adc #$01
	and #$07
	sta ms_idx+1
	tax
	lda adc_vs,x
	sta adc_v+1
	lda eor_vs,x
	sta eor_v+1
	;
	ldx #0				; reset row index
	stx ms_x+1
	stx a_value+1
	rts
	
adc_vs	db $08,$12,$11,$31, $5B,$71,$2E,$0E
eor_vs	db $20,$21,$CC,$00, $04,$04,$17,$00

irq	pha
	txa
	pha
	tya
	pha
	asl $FF09
	jsr PLAYER
	pla
	tay
	pla
	tax
	pla
	rti

	; ORIGINAL CODE:
	
;	ldx sine_index+index		; erase old dot
;	ldy sinetable,x
;	lda #$00
;	sta dest,y
;	;
;	inx				; move dot
;	txa
;	and #$7F
;	sta sine_index+index
;	;
;	tax				; draw new dot
;	ldy sinetable,x
;	lda dest,y
;	ora sinetable+$80,x
;	sta dest,y
	
generate_code
	lda #CODE_DEST & 255		; code is generated to this address
	sta ptr
	lda #CODE_DEST >> 8
	sta ptr+1
	;
	; ---
	;
	ldx #0
	;
	; ---
	;
gc1	stx index
	;
	jsr calc_dest
	;
	ldy #$00
	;
	lda #$A6			; ldx sine_index+index
	jsr putbyte
	lda #sine_index
	clc
	adc index
	jsr putbyte
	;
	lda #$BC			; ldy sinetable,x
	jsr putbyte
	lda #$00
	jsr putbyte
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	lda #$A9			; lda #$00
	jsr putbyte
	lda #$00
	jsr putbyte
	lda #$99			; sta dest,y
	jsr putbyte
	lda dest
	jsr putbyte
	lda dest+1
	jsr putbyte
	;
	lda #$E8			; inx
	;lda #$EA; !!!
	jsr putbyte
	;
	pb $8A				; txa
	;
	pw $29,$7F			; and #$7F
	;
	lda #$85			; sta sine_index+index
	jsr putbyte
	lda #sine_index
	clc
	adc index
	jsr putbyte
	;
	pb $AA				; tax
	;
	lda #$BC			; ldy sinetable,x
	jsr putbyte
	lda #$00
	jsr putbyte
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
;	lda #$B9			; lda dest,y
;	jsr putbyte
;	lda dest
;	jsr putbyte
;	lda dest+1
;	jsr putbyte
;	;
;	lda #$1D			; ora sinetable+$80,x
;	jsr putbyte
;	lda #$80
;	jsr putbyte
;	lda sine_add,x
;	clc
;	adc #sine >> 8
;	jsr putbyte
	;
	lda #$BD			; lda sinetable+$80,x
	jsr putbyte
	lda #$80
	jsr putbyte
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	lda #$99			; sta dest,y
	jsr putbyte
	lda dest
	jsr putbyte
	lda dest+1
	jsr putbyte
	;
	; ---
	;
	inx
	;
	lda $FF07
	and #$40
	beq *+3
	inx				; NTSC: skip one more line
	;
	cpx #25*8
	beq gc2
	jmp gc1
	;
gc2	; ---
	; ================================================
	;
	lda #TXT_FLAGS >> 8
	sta gch+1
	;
	ldy #$00
	ldx #128			; top line
gc4	lda #$00
	sta index
	;
gc3	jsr calc_dest
	;
	pb $AE				; lda$F000+index
	lda index
	jsr putbyte
gch	lda #$00
	jsr putbyte
	;
	pw $F0,$22			; beq *+24
	;
	pb $BC
	pb $00
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	pb $BD				; lda sinetable+$80,x
	pb $80
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	pw $49,$FF			; EOR#$FF
	;
	pb $39
	pzp dest
	pb $99
	pzp dest
	;
	pb $E8				; inx
	;
	pb $8A				; txa
	;
	pw $29,$7F			; and #$7F
	;
	pb $8D
	lda index
	jsr putbyte
	lda gch+1
	jsr putbyte
	;
	pb $AA				; tax
	;
	pb $BC				; ldy sinetable,x
	pb $00
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	pb $B9				; lda dest,y
	pzp dest
	;
	pb $1D				; ora sinetable+$80,x
	pb $80
	lda sine_add,x
	clc
	adc #SINE >> 8
	jsr putbyte
	;
	pb $99				; sta dest,y
	pzp dest
	;
	lda index
	clc
	adc #$02
	sta index
	beq gc5
	jmp gc3
	;
gc5	inc gch+1			; this is adjustable, didn't have time to make the code regenerate this part with params
	inx				; 3 lines skipped
	inx
	inx
	cpx #128+5*3
	beq gc6
	jmp gc4
	;
	; ---
	;	
gc6	ldy #$00
	lda #$60			; RTS
	jsr putbyte
	;
	rts
	
putbyte
	sta (ptr),y
	lda ptr
	clc
	adc #$01
	sta ptr
	bcc *+4
	inc ptr+1
	rts

calc_dest
	lda chr_add,x
	sta dest
	lda #$00
	sta dest+1
	;
	asl dest
	rol dest+1
	asl dest
	rol dest+1
	asl dest
	rol dest+1
	;
	txa
	clc
	adc dest
	sta dest
	lda dest+1
	adc #CHARS >> 8
	sta dest+1
	;
	lda chr_sub,x
	bne gca
	;
	dec dest+1
	jmp gcb
	;
gca	lda dest
	sec
	sbc chr_sub,x
	sta dest
	lda dest+1
	sbc #$00
	sta dest+1
	;
gcb	rts

write_text
txt_delay
	lda #$01
	clc
	adc #$01
	and #$01
	sta txt_delay+1
	bne gcb
	;
col_idx	ldx #$FE
	;
	ldy #$00
	lda (chr_ptr),y
	sta TXT_FLAGS+$400,x
	iny
	lda (chr_ptr),y
	sta TXT_FLAGS+$300,x
	iny
	lda (chr_ptr),y
	sta TXT_FLAGS+$200,x
	iny
	lda (chr_ptr),y
	sta TXT_FLAGS+$100,x
	iny             
	lda (chr_ptr),y
	sta TXT_FLAGS+$000,x
	;
	;dex
	;dex
	;
	;ldy #$00
	;lda #$00
	;sta TXT_FLAGS,x
	;sta TXT_FLAGS+$100,x
	;sta TXT_FLAGS+$200,x
	;sta TXT_FLAGS+$300,x
	;sta TXT_FLAGS+$400,x
	;
	; ---
	;
	lda col_idx+1
	sec
	sbc #$02
	sta col_idx+1
	;
	lda chr_ptr
	clc
	adc #$05
	sta chr_ptr
	bcc *+4
	inc chr_ptr+1
	;
letter_col_idx
	ldx #$00
	inx
	cpx #$06
	bne wt1
	;
	lda txt_ptr
	clc
	adc #$01
	sta txt_ptr
	bcc *+4
	inc txt_ptr+1
	;
	ldy #$00
wt3	lda (txt_ptr),y
	bpl wt2
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	bne wt3
	;
wt2	sta chr_ptr
	lda #$00
	sta chr_ptr+1
	;
	asl chr_ptr
	rol chr_ptr+1
	asl chr_ptr
	rol chr_ptr+1
	asl chr_ptr
	rol chr_ptr+1
	asl chr_ptr
	rol chr_ptr+1
	asl chr_ptr
	rol chr_ptr+1
	;
	lda chr_ptr
	clc
	adc #char_data & 255
	sta chr_ptr
	lda chr_ptr+1
	adc #char_data >> 8
	sta chr_ptr+1
	;
	ldx #$00
	;
wt1	stx letter_col_idx+1
	;
	rts
	
sine_add
	db $47,$47,$47,$46,$46,$46,$45,$45
	db $44,$44,$44,$43,$43,$42,$42,$42
	db $41,$41,$40,$40,$40,$3F,$3F,$3E
	db $3E,$3E,$3D,$3D,$3C,$3C,$3C,$3B
	db $3B,$3B,$3A,$3A,$39,$39,$39,$38
	db $38,$37,$37,$37,$36,$36,$35,$35
	db $35,$34,$34,$33,$33,$33,$32,$32
	db $31,$31,$31,$30,$30,$2F,$2F,$2F
	db $2E,$2E,$2E,$2D,$2D,$2C,$2C,$2C
	db $2B,$2B,$2A,$2A,$2A,$29,$29,$28
	db $28,$28,$27,$27,$26,$26,$26,$25
	db $25,$24,$24,$24,$23,$23,$23,$22
	db $22,$21,$21,$21,$20,$20,$1F,$1F
	db $1F,$1E,$1E,$1D,$1D,$1D,$1C,$1C
	db $1B,$1B,$1B,$1A,$1A,$19,$19,$19
	db $18,$18,$17,$17,$17,$16,$16,$16
	db $15,$15,$14,$14,$14,$13,$13,$12
	db $12,$12,$11,$11,$10,$10,$10,$0F
	db $0F,$0E,$0E,$0E,$0D,$0D,$0C,$0C
	db $0C,$0B,$0B,$0B,$0A,$0A,$09,$09
	db $09,$08,$08,$07,$07,$07,$06,$06
	db $05,$05,$05,$04,$04,$03,$03,$03
	db $02,$02,$01,$01,$01,$00,$00,$00
	;
	db $40,$40,$40,$40,$40,$40,$40,$40	; trunk
	db $40,$40,$40,$40,$40,$40,$40,$40
	
chr_sub
	db $40,$40,$40,$40,$40,$40,$40,$40
	db $48,$48,$48,$48,$48,$48,$48,$48
	db $48,$48,$48,$48,$48,$48,$48,$48
	db $50,$50,$50,$50,$50,$50,$50,$50
	db $58,$58,$58,$58,$58,$58,$58,$58
	
	db $58,$58,$58,$58,$58,$58,$58,$58
	db $60,$60,$60,$60,$60,$60,$60,$60
	db $60,$60,$60,$60,$60,$60,$60,$60
	db $68,$68,$68,$68,$68,$68,$68,$68
	db $70,$70,$70,$70,$70,$70,$70,$70
	
	db $70,$70,$70,$70,$70,$70,$70,$70
	db $78,$78,$78,$78,$78,$78,$78,$78
	db $78,$78,$78,$78,$78,$78,$78,$78
	db $80,$80,$80,$80,$80,$80,$80,$80
	db $88,$88,$88,$88,$88,$88,$88,$88
	
	db $88,$88,$88,$88,$88,$88,$88,$88
	db $90,$90,$90,$90,$90,$90,$90,$90
	db $90,$90,$90,$90,$90,$90,$90,$90
	db $98,$98,$98,$98,$98,$98,$98,$98
	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	
	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A0
	db $A8,$A8,$A8,$A8,$A8,$A8,$A8,$A8
	db $B0,$B0,$B0,$B0,$B0,$B0,$B0,$B0
	
	db $F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8
	db $00,$00,$00,$00,$00,$00,$00,$00

chr_add
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $02,$02,$02,$02,$02,$02,$02,$02
	db $04,$04,$04,$04,$04,$04,$04,$04
	db $08,$08,$08,$08,$08,$08,$08,$08
	db $0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C
	db $10,$10,$10,$10,$10,$10,$10,$10
	db $16,$16,$16,$16,$16,$16,$16,$16
	db $1C,$1C,$1C,$1C,$1C,$1C,$1C,$1C
	db $24,$24,$24,$24,$24,$24,$24,$24
	db $2C,$2C,$2C,$2C,$2C,$2C,$2C,$2C
	db $34,$34,$34,$34,$34,$34,$34,$34
	db $3E,$3E,$3E,$3E,$3E,$3E,$3E,$3E
	db $48,$48,$48,$48,$48,$48,$48,$48
	db $54,$54,$54,$54,$54,$54,$54,$54
	db $60,$60,$60,$60,$60,$60,$60,$60
	db $6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C
	db $7A,$7A,$7A,$7A,$7A,$7A,$7A,$7A
	db $88,$88,$88,$88,$88,$88,$88,$88
	db $98,$98,$98,$98,$98,$98,$98,$98
	db $A8,$A8,$A8,$A8,$A8,$A8,$A8,$A8
	db $B8,$B8,$B8,$B8,$B8,$B8,$B8,$B8
	db $CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA
	db $DC,$DC,$DC,$DC,$DC,$DC,$DC,$DC
	db $EE,$EE,$EE,$EE,$EE,$EE,$EE,$EE
	db $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
	
widths
	db  2, 2, 4, 4, 4
	db  6, 6, 8, 8, 8
	db 10,10,12,12,12
	db 14,14,16,16,16
	db 18,18,18
	db  2, 2 ; trunk
	
text_data
	cmap " ",0
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "!",27
	cmap "/",28
	cmap "4",29
	cmap "@",30
	cmap "0",31
	cmap "&",32
	db "                                         "
	db "                                         "
	db "MERRY CHRISTMAS!"
	db "         "
	db "BOLDOG KAR@CSONYT!"
	db "         "
	db "FR0HLICHE WEIHNACHTEN!"
	db "         "
	db "BUON NATALE!"
	db "         "
	db "HYV&& JOULUA!"
	db "         "
	db "CSABO OF LOD IS HERE TO WISH YOU A MERRY CHRISTMAS AND HAPPY HOLIDAYS!"
	db "         "
	db "GREETINGS TO ALL PLUS/4 SCENERS!"
	db "         "
	db "KEEP THE SCENE ALIVE!"
	db "         "
	db $FF
	
char_data
	cmap " ",0
	cmap "*",1
	
	db "     "	; space
	db "     "
	db "     "
	db "     "
	db "     "
	db "     ",0,0
	
	db "**** "	; A
	db "  * *"
	db "  * *"
	db "  * *"
	db "**** "
	db "     ",0,0
	
	db "*****"	; B
	db "* * *"
	db "* * *"
	db "* * *"
	db " * * "
	db "     ",0,0
	
	db " *** "	; C
	db "*   *"
	db "*   *"
	db "*   *"
	db " * * "
	db "     ",0,0
	
	db "*****"	; D
	db "*   *"
	db "*   *"
	db "*   *"
	db " *** "
	db "     ",0,0
	
	db "*****"	; E
	db "* * *"
	db "* * *"
	db "*   *"
	db "*   *"
	db "     ",0,0
	
	db "*****"	; F
	db "  * *"
	db "  * *"
	db "    *"
	db "    *"
	db "     ",0,0
	
	db " *** "	; G
	db "*   *"
	db "* * *"
	db "* * *"
	db " **  "
	db "     ",0,0
	
	db "*****"	; H
	db "  *  "
	db "  *  "
	db "  *  "
	db "*****"
	db "     ",0,0
	
	db "*   *"	; I
	db "*   *"
	db "*****"
	db "*   *"
	db "*   *"
	db "     ",0,0
	
	db " *   "	; J
	db "*    "
	db "*    "
	db "*    "
	db " ****"
	db "     ",0,0
	
	db "*****"	; K
	db "  *  "
	db "  *  "
	db " * * "
	db "*   *"
	db "     ",0,0
	
	db "*****"	; L
	db "*    "
	db "*    "
	db "*    "
	db "*    "
	db "     ",0,0
	
	db "*****"	; M
	db "   * "
	db "  *  "
	db "   * "
	db "*****"
	db "     ",0,0
	
	db "*****"	; N
	db "   * "
	db "  *  "
	db " *   "
	db "*****"
	db "     ",0,0
	
	db " *** "	; O
	db "*   *"
	db "*   *"
	db "*   *"
	db " *** "
	db "     ",0,0
	
	db "*****"	; P
	db "  * *"
	db "  * *"
	db "  * *"
	db "   * "
	db "     ",0,0
	
	db " *** "	; Q
	db "*   *"
	db "*   *"
	db "**  *"
	db "**** "
	db "     ",0,0
	
	db "*****"	; R
	db "  * *"
	db "  * *"
	db " ** *"
	db "*  * "
	db "     ",0,0
	
	db "*  * "	; S
	db "* * *"
	db "* * *"
	db "* * *"
	db " *   "
	db "     ",0,0
	
	db "    *"	; T
	db "    *"
	db "*****"
	db "    *"
	db "    *"
	db "     ",0,0
	
	db " ****"	; U
	db "*    "
	db "*    "
	db "*    "
	db " ****"
	db "     ",0,0
	
	db "  ***"	; V
	db " *   "
	db "*    "
	db " *   "
	db "  ***"
	db "     ",0,0
	
	db "*****"	; W
	db " *   "
	db "  *  "
	db " *   "
	db "*****"
	db "     ",0,0
	
	db "*   *"	; X
	db " * * "
	db "  *  "
	db " * * "
	db "*   *"
	db "     ",0,0
	
	db "    *"	; Y
	db "   * "
	db "***  "
	db "   * "
	db "    *"
	db "     ",0,0
	
	db "*   *"	; Z
	db "**  *"
	db "* * *"
	db "*  **"
	db "*   *"
	db "     ",0,0
	
	db "     "	; !
	db "     "
	db "* ***"
	db "     "
	db "     "
	db "     ",0,0
	
	db "*    "	; /
	db " *   "
	db "  *  "
	db "   * "
	db "    *"
	db "     ",0,0
	
	db " *   "	; 4
	db " **  "
	db " * * "
	db "*****"
	db " *   "
	db "     ",0,0
	
	db "***  "	; 
	db " * * "
	db " * **"
	db " * * "
	db "***  "
	db "     ",0,0
	
	db " ** *"	; 
	db "*  * "
	db "*  * "
	db "*  * "
	db " ** *"
	db "     ",0,0
	
	db "*** *"	; 
	db " * * "
	db " * * "
	db " * * "
	db "*** *"
	db "     ",0,0
	
	align $2000
	include "pic.asm"

;eof